/***************************************************************
 * Name:      wxRenderTimerSmithMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Herman ()
 * Created:   2014-04-07
 * Copyright: Herman ()
 * License:
 **************************************************************/

#include "wxRenderTimerSmithMain.h"
#include <wx/msgdlg.h>
#include <wx/dcclient.h>

//(*InternalHeaders(wxRenderTimerSmithFrame)
#include <wx/intl.h>
#include <wx/string.h>
//*)

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(wxRenderTimerSmithFrame)
const long wxRenderTimerSmithFrame::ID_BUTTON1 = wxNewId();
const long wxRenderTimerSmithFrame::ID_PANEL1 = wxNewId();
const long wxRenderTimerSmithFrame::idMenuQuit = wxNewId();
const long wxRenderTimerSmithFrame::idMenuAbout = wxNewId();
const long wxRenderTimerSmithFrame::ID_STATUSBAR1 = wxNewId();
const long wxRenderTimerSmithFrame::ID_TIMER1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(wxRenderTimerSmithFrame,wxFrame)
    //(*EventTable(wxRenderTimerSmithFrame)
    //*)
END_EVENT_TABLE()

wxRenderTimerSmithFrame::wxRenderTimerSmithFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(wxRenderTimerSmithFrame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(400,400));
    Button1 = new wxButton(this, ID_BUTTON1, _("Start"), wxPoint(264,304), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    Panel1 = new wxPanel(this, ID_PANEL1, wxPoint(0,8), wxSize(392,264), wxTAB_TRAVERSAL, _T("ID_PANEL1"));
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, 0, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[1] = { -1 };
    int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
    StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);
    Timer1.SetOwner(this, ID_TIMER1);

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxRenderTimerSmithFrame::OnButton1Click);
    Panel1->Connect(wxEVT_PAINT,(wxObjectEventFunction)&wxRenderTimerSmithFrame::OnPanel1Paint,0,this);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxRenderTimerSmithFrame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxRenderTimerSmithFrame::OnAbout);
    Connect(ID_TIMER1,wxEVT_TIMER,(wxObjectEventFunction)&wxRenderTimerSmithFrame::OnTimer1Trigger);
    //*)
}

wxRenderTimerSmithFrame::~wxRenderTimerSmithFrame()
{
    //(*Destroy(wxRenderTimerSmithFrame)
    //*)
}

void wxRenderTimerSmithFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void wxRenderTimerSmithFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Welcome to..."));
}


void wxRenderTimerSmithFrame::OnPanel1Paint(wxPaintEvent& event)
{

   wxPaintDC dc(Panel1);
//   render(dc);
// this is the code from the render function
//  http://web.eng.fiu.edu/~watsonh/eel3160/ProgOfWeek/RenderTimer.cpp
// also have to include dc definitions - #include <wx/dcclient.h>

    static int y = 0;
    static int y_speed = 2;

    y += y_speed;
    if(y<0) y_speed = 2;
    if(y>200) y_speed = -2;

    dc.SetBackground( *wxWHITE_BRUSH );
    dc.Clear();
    dc.DrawText(wxT("Testing"), 40, y);


 }


void wxRenderTimerSmithFrame::OnTimer1Trigger(wxTimerEvent& event)
{
  Panel1->Refresh();
}

void wxRenderTimerSmithFrame::OnButton1Click(wxCommandEvent& event)
{
    Timer1.Start(20, false);

}
